/*
 *   Copyright (C) 2007 Ivan Cukic <ivan.cukic+kde@gmail.com>
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU Lesser/Library General Public License version 2,
 *   or (at your option) any later version, as published by the Free
 *   Software Foundation
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU Lesser/Library General Public License for more details
 *
 *   You should have received a copy of the GNU Lesser/Library General Public
 *   License along with this program; if not, write to the
 *   Free Software Foundation, Inc.,
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */

#ifndef COMMON_FUNCTIONS_H_
#define COMMON_FUNCTIONS_H_

#include <QObject>
#include <QString>

class QNetworkReply;
class QUrl;

namespace CustomWidgets {

class Common {
public:
    static QString readFile(const QString & fileName);
};

class HttpReader: public QObject {
    Q_OBJECT
public:
    HttpReader();

    void read(const QUrl & url);

Q_SIGNALS:
    void finished(const QString data);

protected Q_SLOTS:
    void networkReplyFinished(QNetworkReply * reply);

private:
    class Private;
    Private * const d;
};

} // namespace CustomWidgets

#endif // COMMON_FUNCTIONS_H_
